;***************************************************************
;Programa, uraanti visus rastus faile skaiius odiais. 
;Rezultatas isaugomas kitame nurodytame faile.  
;* Atliko : , II kursas , 2 grupe                     
;* 2009-11-15                                                     
;***************************************************************

.model small

skBufDydis	EQU 20			;konstanta skBufDydis (lygi 20) - skaitymo buferio dydis

.stack 100h

.data 

    duom	 DB 255 dup (0)			; duomenu failo vieta pavadinimui
     rez	 DB 255 dup (0)			; rezultatu duomenu failo vieta pavadinimui	
	
     skBuf	db skBufDydis dup ('$')	;skaitymo buferis
	
	dFail	dw ?			;vieta, skirta saugoti duomen failo deskriptoriaus numer ("handle")
	rFail	dw ?			;vieta, skirta saugoti rezultato failo deskriptoriaus numer


	simbolis db ?
	buffer  db  20 dup ('$') 
	nulis   db 'Nulis$'
	vienas  db 'Vienas$'
	du      db 'Du$'
	trys    db 'Trys$'
	keturi  db 'Keturi$'
	penki   db 'Penki$'
	sesi    db 'Sesi$'
	septyni db 'Septyni$'
	astuoni db 'Astuoni$'
	devyni  db 'Devyni$'

	;Pagalbos praneimas:   
	
	    help		db "Programa, uraanti visus rastus faile skaiius odiais. Rezultatas isaugomas kitame nurodytame faile", 10, 13,"Duomenu failas sukurtas is anksto.", 10, 13, "Sekmes"
	;Klaidu pranesimai
	                Nei	 DB 'Klaida! Netinkamai ivesti duomenys!', 10, 13
         AtidarantSk	 DB 'Klaida atidarant  faila skaitymui!',10,13	
    AtidarantRasymui	 DB 'Klaida atidarant failus rasymui!',10,13		
        klaidaSkaitant1	 DB 'Klaida skaitant failus!',10,13			
        UzdarantRasymui	 DB 'Klaida uzdarant  faila!',10,13		
	 UzdarantSkaitymui	 DB 'Klaida uzdarant skaitymo failus!',10,13	
.code

  pradzia:
	MOV	ax, @data		;reikalinga kiekvienos programos pradioj
	MOV	ds, ax			;reikalinga kiekvienos programos pradioj
    MOV	bx, 0081h		;programos paleidimo parametrai raomi segmente es pradedant 129 (arba 81h) baitu    
    
  
    
    Ieskok:
	MOV	ax, es:[bx]				; i ax irasom du baitus, i kuriuos rodo registro turinio adresas bx
	CMP	al, 0Dh					; tikrinam, ar tai ne pabaigos simbolis (paliginam al su pabaigos simboliu '0Dh' ascii kodo lentelej)
	JE	Nera					; jei taip, vadinasi neradau '/?', persokam i 'nera'
	CMP	ax, 3F2Fh				; o gal nuskaityta '/?' - 3F = '?'; 2F = '/' (paliginam ax su 3F2F)
	JE	Yra             	    ; radau '/?', vadinasi turiu isvesti pagalbos pranesima, persokam i 'Yra'
	INC	bx					    ; neradau '/?' siuose baituose, paslenku rodykli (padidinu bx vienetu) ir tikrinu toliau esancius baitus ar ten yra parametras
	JMP	Ieskok					; uzciklinu, pradedem cikla 'Ieskok' is naujo...
    
    
  Yra:							; spausdinu pagalba i ekrana
	 
	MOV	dx, offset help		    ; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 136
	Call    Write
    JMP	Pabaiga					; persoka i kintameji 'Pabaiga'  
          
          


;******************************************************************************
;  Duomenu failo vardo ieskojimas ir irasymas
;******************************************************************************
Nera:
	MOV	si, 0080h
 
SpaceSearch1:						; ieskom komandineje eiluteje simbolio nelygaus tarpui
	INC	si							; padidinam si vienetu
	MOV	al, es:[si]					; i al irasom viena simboli, nuskaityta is komandines eilutes
	CMP	al, ' '						; patikrinam ar nuskaitytas simbolis nera tarpas
	JE	SpaceSearch1				; jei al=' ', tai uzciklinam 'SpaceSearch1'
	MOV	bx, offset duom			    ; i bx ikeliam 'duom' adresa, kur bus saugomas  duomenu failo vardas
 
NameSearch1:
	MOV	al, es:[si]					; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si							; padidinam si vienetu, kad imtume kita simboli is komandine eilutes
	CMP	al, 0Dh						; patikrinam ar nuskaitytas simbolis nera Enter
	JNC	IeskokToliau1			    ; jei ieskant 1 duomenu failo varda neivyksta klaidos, nustatomas carry flag (CF=0) , persokam i 'IeskokToliau1'
	CALL	Neivesta		        ; jei atidarant faila skaitymui ivyksta klaida, nustatomas cary flag (CF=1), persokam i 'Neivesta'
 
IeskokToliau1:
	CMP	al, ' '						; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	SpaceSearch2					; jei tai yra Enter persokam i 'SpaceSearch2'
	MOV	ds:[bx], al					; i pirmojo failo varda irasom simboli is komandines eilutes
	INC	bx							; padidinam bx vienetu
	JMP	NameSearch1					; persokam i 'NameSearch1', pildom iki galo 1 duomenu failo varda 
         
         
;******************************************************************************
; Rezultato failo vardo ieskojimas ir irasymas
;******************************************************************************
SpaceSearch2:						; ieskom komandineje eiluteje ne tarpa
	MOV	al, es:[si]					; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si							; padidinam si vienetu
	CMP	al, ' '						; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	SpaceSearch2				; jei al=' ', tai uzciklinam 'SpaceSearch3'
	DEC	si							; sumazinam SOURCE INDEX reiksme vienetu, kad matytumem ta nelygu "SPACE" simboli
	MOV	al, es:[si]					; i al irasom ta simboli nelygu tarpui
	CMP	al, 0Dh						; patikrinam ar irasytas simbolis nera Enter
	JNC IeskokToliau2				; jei ieskant rezultato failo varda neivyksta klaidos, nustatomas carry flag (CF=0) , persokam i 'IeskokToliau3'
	CALL	Neivesta					; jei tai yra Enter persokam i 'Neivesta'
 
IeskokToliau2:
	MOV	bx, offset rez			; i bx ikeliam 'rezu' adresa, kur bus saugomas pirma failo vardas
 
NameSearch2:
	MOV	al, es:[si]					; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si							; padidinam si vienetu
	CMP	al, 0Dh						; patikrinam ar nuskaitytas simbolis nera Enter
	JE	Skaitom
 
	CMP	al, ' '	    				; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	NameSearch2					; jei tai yra tarpas, tai tikrinsiu tolimesni komandines eilutes simboli, persokam i 'NameSearch2'
	MOV	ds:[bx], al					; i pirmojo failo varda irasom simboli is komandines eilutes
	INC	bx							; padidinam bx vienetu
	JMP	NameSearch2					; persokam i 'NameSearch2'  
	
	
;*****************************************************
;Duomen failo atidarymas skaitymui
;*****************************************************   
	MOV ax, ds					; i ax ikeliam ds
	MOV	es, ax					; i es ikeliam ax (tai reiskia ds), sulyginam ds ir es    
	  
Skaitom:	  
	MOV	ah, 3Dh				;21h pertraukimo failo atidarymo funkcijos numeris
	MOV	al, 00				;00 - failas atidaromas skaitymui
	MOV	dx, offset duom			;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h				;failas atidaromas skaitymui
	JC	klaidaAtidarantSkaitymui	;jei atidarant fail skaitymui vyksta klaida, nustatomas carry flag
	MOV	dFail, ax			;atmintyje isisaugom duomen failo deskriptoriaus numer

  
  

   

;*****************************************************
;Rezultato failo sukrimas ir atidarymas raymui
;*****************************************************
	MOV	ah, 3Ch				;21h pertraukimo failo sukrimo funkcijos numeris
	MOV	cx, 0				;kuriamo failo atributai
	MOV	dx, offset rez			;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h				;sukuriamas failas; jei failas jau egzistuoja, visa jo informacija itrinama
	JC	klaidaAtidarantRasymui		;jei kuriant fail skaitymui vyksta klaida, nustatomas carry flag
	MOV	rFail, ax
    
    MOV ax, ds					; i ax ikeliam ds
	MOV	es, ax					; i es ikeliam ax (tai reiskia ds), sulyginam ds ir es
	XOR	ax, ax					; nunulinan ax registra, kad netycia kur nors nepanaudoti failo deskriptoriaus      
	

	

	
	
	
 
;*****************************************************
;Duomen nuskaitymas i failo
;*****************************************************
  skaityk:
	MOV	bx, dFail			; bx raom duomen failo deskriptoriaus numer
	CALL	SkaitykBuf			;ikvieiame skaitymo i failo procedr
	CMP	ax, 0				;ax raoma, kiek bait buvo nuskaityta, jeigu 0 - pasiekta failo pabaiga
	JE	uzdarytiRasymui








;*****************************************************
;Darbas su nuskaityta informacija
;*****************************************************
  mov SI, offset skBuf  ;  i si permetame skBuf adresa

atrenka:
    xor ax, ax
    lodsb  
    push cx
    cmp al, '$'
    je uzdarytiRasymui 
    call indent
    call print
    jc Pabaiga
    pop cx
    loop atrenka
    CMP	ax, skBufDydis			;jeigu vyko darbas su pilnu buferiu -> i duomen failo buvo nuskaitytas pilnas buferis ->
    JE	skaityk				;-> reikia skaityti toliau








;*****************************************************
;Rezultato failo udarymas
;*****************************************************
  uzdarytiRasymui:
	MOV	ah, 3Eh				;21h pertraukimo failo udarymo funkcijos numeris
	MOV	bx, rFail			; bx raom rezultato failo deskriptoriaus numer
	INT	21h				;failo udarymas
	JC	klaidaUzdarantRasymui		;jei udarant fail vyksta klaida, nustatomas carry flag



;*****************************************************
;Duomen failo udarymas
;*****************************************************
  uzdarytiSkaitymui:
	MOV	ah, 3Eh				;21h pertraukimo failo udarymo funkcijos numeris
	MOV	bx, dFail			; bx raom duomen failo deskriptoriaus numer
	INT	21h				    ;failo udarymas
	JC	klaidaUzdarantSkaitymui		;jei udarant fail vyksta klaida, nustatomas carry flag




  Pabaiga:
	MOV	ah, 4Ch			;reikalinga kiekvienos programos pabaigoj
	MOV	al, 0			;reikalinga kiekvienos programos pabaigoj
	INT	21h			;reikalinga kiekvienos programos pabaigoj




;*****************************************************
;Klaid apdorojimas
;***************************************************** 

  klaidaAtidarantSkaitymui:
	MOV	dx, offset AtidarantSk		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 40
	Call    Write
	JMP	pabaiga
  klaidaAtidarantRasymui:
	MOV	dx, offset AtidarantRasymui		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 40
	Call    Write
	JMP	uzdarytiSkaitymui
  klaidaUzdarantRasymui:
	MOV	dx, offset UzdarantRasymui		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 40
	Call    Write
	JMP	uzdarytiSkaitymui
  klaidaUzdarantSkaitymui:
	MOV	dx, offset UzdarantSkaitymui		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 40
	Call    Write
	JMP	pabaiga
 
  Neivesta:								; klaidos pranesimo ivedimo kodas
   MOV	dx, offset nei		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 36
	Call    Write
	JMP	Pabaiga

  

;*****************************************************
;Procedra nuskaitanti informacij i failo
;*****************************************************
SkaitykBuf PROC
; BX paduodamas failo deskriptoriaus numeris
; AX bus grinta, kiek simboli nuskaityta
	PUSH	cx
	PUSH	dx
	
	MOV	ah, 3Fh			;21h pertraukimo duomen nuskaitymo funkcijos numeris
	MOV	cl, skBufDydis		;cx - kiek bait reikia nuskaityti i failo
	MOV	ch, 0			;ivalom vyresnj cx bait
	MOV	dx, offset skBuf	;vieta,  kuri raoma nuskaityta informacija
	INT	21h			;skaitymas i failo
	JC	klaidaSkaitant		;jei skaitant i failo vyksta klaida, nustatomas carry flag

  SkaitykBufPabaiga:
	POP	dx
	POP	cx
	RET

  klaidaSkaitant:
	MOV	dx, offset klaidaSkaitant1 		; dx raau nuorod  spausdinamo teksto pradi   
	MOV cx, 104
	Call    Write
	MOV ax, 0			;Paymime registre ax, kad nebuvo nuskaityta n vieno simbolio
	JMP	SkaitykBufPabaiga
SkaitykBuf ENDP



;*****************************************************
;Procedra indentifikuojanti skaiciu
;*****************************************************
indent PROC  near
 
    cmp al, '0'
    je sk0
    cmp al, '1'
    je sk1  
    cmp al, '2'
    je sk2
    cmp al, '3'
    je sk3  
    cmp al, '4'
    je sk4
    cmp al, '5'
    je sk5  
    cmp al, '6'
    je sk6
    cmp al, '7'
    je sk7
    cmp al, '8'
    je sk8
    cmp al, '9'
    je sk9 
   

    mov cx, 1
    mov simbolis, al
    lea dx, simbolis
    ret	




sk0:
    lea dx, nulis
    mov cx, 5        ;nurodom kiek baitu spauzdinsim
    ret
sk1:
    lea dx, vienas
    mov cx, 6
    ret 
sk2:
    lea dx, du
    mov cx, 2
    ret
sk3:
    lea dx, trys
    mov cx, 4
    ret       
sk4:
    lea dx, keturi
    mov cx, 6
    ret
sk5:
    lea dx, penki
    mov cx, 5
    ret
sk6:
    lea dx, sesi
    mov cx, 4
    ret
sk7:
    lea dx, septyni
    mov cx, 7
    ret
sk8:
    lea dx, astuoni
    mov cx, 7
    ret
sk9:
    lea dx, devyni
    mov cx, 6
    ret

 
indent ENDP

print PROC 
 
    mov bx, rFail
    mov ah, 40h
    int 21h
    ret 
 
print ENDP  


;*****************************************************
;Procedra isvedanti i ekrana pranesima i stdout
;*****************************************************
Write	PROC
	push AX
    push BX
     
        
	
        MOV	ah, 40h			;DOS funkcijos numeris
        MOV	bx, 1			;STDOUT (Standart output) renginio deskriptoriaus numeris
        
	    INT 21h			        ;int 21,09 - isvedimas i ekrana
     
        xor CX, CX
        pop BX
	pop AX
	ret
Write	ENDP

    
END pradzia